#include <iostream>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int h,n;
    cin>>h>>n;
    int m[h][n];
    for(int i=0;i<h;i++)
        for(int j=0;j<n;j++)
            cin>>m[i][j];
    int rez[n];
    for(int i=0;i<n;i++)
        rez[i]=1;
    for(int i=0;i<h;i++)
        for(int j=0;j<n;j++)
            if(m[i][j]==0)
            {
                int l,d;
                l=j;
                d=l;
                while(m[i][d]==0)
                {
                    d++;
                    j++;
                }
                d--;
                int s=0;
                for(int q=l;q<=d;q++)
                {
                    s+=rez[q];
                    rez[q]=0;
                }
                if((l==0)||(d==n-1))
                {
                    if(l==0)
                        rez[d+1]+=s;
                    else
                        rez[l-1]+=s;
                }
                else
                {
                    if(s%2==0)
                    {
                        rez[l-1]+=s/2;
                        rez[d+1]+=s/2;
                    }
                    else
                    {
                        if((i+1)%2==1)
                        {
                            rez[l-1]+=s/2+1;
                            rez[d+1]+=s/2;
                        }
                        else
                        {
                            rez[l-1]+=s/2;
                            rez[d+1]+=s/2+1;
                        }
                    }

                }

            }
    for(int i=0;i<n;i++)
        cout<<rez[i]<<" ";
    return 0;
}